//+------------------------------------------------------------------+
//|                                             Volatility.Pivot.mq4 |
//|                                               mod by NiX 2007    |
//|                                 modified by barmenteros.com 2015 |
//|                                     support.team@barmenteros.com |
//+------------------------------------------------------------------+
#property copyright "thanks to S.B.T. (Japan)"
#property link      "http://sufx.core.t3-ism.net/" //<<< convert this from VT, thanks mate !!!

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Orange
#property indicator_color3 Blue
//---- input parameters
extern double     atr_range=100;
extern double     ima_range = 10;
extern double     atr_factor=3;
extern int        Mode = 0;
extern double     DeltaPrice = 30;

extern string set2="---------- MA setting";
input  int        MA_Period                  =21;  // MA Period
       int        MA_Shift                   =0;   // MA Shift
input  ENUM_MA_METHOD      MA_Method         =MODE_EMA;   // MA Smoothing Method
       ENUM_APPLIED_PRICE  MA_Price          =0;   // MA Applied Price
       
extern string setM="---------- Alerts";
extern bool      DialogBoxAlert =true; // Enable Pop Up Alert
extern bool      SoundAlert =false; // Enable Sound Alert
extern string    SoundFile ="news.wav"; // Sound File

//---- buffers
double TrStop[];
double ATR[];
double MA_Bfr[];

//+------------------------------------------------------------------+
//| TimeFrameToString
//+------------------------------------------------------------------+
string TimeFrameToString( int timeframe, int mode=1 )
  {
   string s_function_name = "TimeFrameToString";
//----
   switch( timeframe )
      {
       case PERIOD_M1:  if( mode == 1 )   { return("M1");         break; }
                        else              { return("1 minute");   break; }
       case PERIOD_M5:  if( mode == 1 )   { return("M5");         break; }
                        else              { return("5 minutes");  break; }
       case PERIOD_M15: if( mode == 1 )   { return("M15");        break; }
                        else              { return("15 minutes"); break; }
       case PERIOD_M30: if( mode == 1 )   { return("M30");        break; }
                        else              { return("30 minutes"); break; }
       case PERIOD_H1:  if( mode == 1 )   { return("H1");         break; }
                        else              { return("1 hour");     break; }
       case PERIOD_H4:  if( mode == 1 )   { return("H4");         break; }
                        else              { return("4 hour");     break; }
       case PERIOD_D1:  if( mode == 1 )   { return("D1");         break; }
                        else              { return("Daily");      break; }
       case PERIOD_W1:  if( mode == 1 )   { return("W1");         break; }
                        else              { return("Weekly");     break; }
       case PERIOD_MN1: if( mode == 1 )   { return("MN1");        break; }
                        else              { return("Monthly");    break; }
       case 0:          if( mode == 1 )   { return("Current");    break; }
                        else              { return("Current TF"); break; }
       default: return( StringConcatenate( timeframe," timeframe is not available" ) );
      }
//----
   return("");
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(0, TrStop);

   SetIndexStyle(1, DRAW_NONE);
   SetIndexBuffer(1, ATR);
   
   SetIndexStyle(2, DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(2, MA_Bfr);

   string short_name = "VPO";
   IndicatorShortName(short_name);
   SetIndexLabel(1,"ATR");
   SetIndexLabel(2,"MA("+MA_Period+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
   int limit;
   int i;

   double DeltaStop;
   
   limit = Bars;

   for(i = 0; i < limit; i ++) {
      ATR[i] = iATR(NULL,0,atr_range,i);
      MA_Bfr[i] = iMA(NULL, 0, MA_Period, MA_Shift, MA_Method, MA_Price, i);
   }

   for(i = limit - 1; i >= 0; i --) {
      if (Mode == 0) {
         DeltaStop = iMAOnArray(ATR,0,ima_range,0,MODE_EMA,i) * atr_factor;
         //DeltaStop = iATR(NULL,0,atr_range,i) * atr_factor;
      } else {
         DeltaStop = DeltaPrice*Point;
      }

      if (Open[i] == TrStop[i + 1]) {
         TrStop[i] = TrStop[i + 1];
      } else {
         if (Open[i+1]<TrStop[i+1] && Open[i]<TrStop[i+1]) {
            TrStop[i] = MathMin(TrStop[i + 1], Open[i] + DeltaStop);
         } else {
            if (Open[i+1]>TrStop[i+1] && Open[i]>TrStop[i+1]) {
               TrStop[i] = MathMax(TrStop[i+1], Open[i] - DeltaStop);         
            } else {
               if (Open[i] > TrStop[i+1]) TrStop[i] = Open[i] - DeltaStop; else TrStop[i] = Open[i] + DeltaStop;
            }
         }
      }
   }

   // alerts
   static datetime sdt_SignalOpenTime = 0;
   if(sdt_SignalOpenTime != Time[0] &&
      MA_Bfr[2] <= TrStop[2] &&
      MA_Bfr[1] > TrStop[1])
     {
      Print( "UPWARD SIGNAL" );
      sdt_SignalOpenTime = Time[0];
      if( SoundAlert ) // if true, a sound will be played
         {
          PlaySound( SoundFile );
         }
      if( DialogBoxAlert ) // if true, a dialog box will be displayed
         {
          Alert( "VPO UPWARD SIGNAL - ",Symbol()," ",TimeFrameToString( _Period )," CHART" );
         } // if true, a dialog box will be displayed END
     }
   if(sdt_SignalOpenTime != Time[0] &&
      MA_Bfr[2] >= TrStop[2] &&
      MA_Bfr[1] < TrStop[1])
     {
      Print( "DOWNWARD SIGNAL" );
      sdt_SignalOpenTime = Time[0];
      if( SoundAlert ) // if true, a sound will be played
         {
          PlaySound( SoundFile );
         }
      if( DialogBoxAlert ) // if true, a dialog box will be displayed
         {
          Alert( "VPO DOWNWARD SIGNAL - ",Symbol()," ",TimeFrameToString( _Period )," CHART" );
         } // if true, a dialog box will be displayed END
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+